/* Copyright (C) 1995 Charles Sandmann (sandmann@clio.rice.edu)
   This software may be freely distributed with above copyright, no warranty.
   Based on code by DJ Delorie, it's really his, enhanced, bugs fixed. */

/* Original code by DJ Delorie and Charles Sandmann edited to furthur the
   development of DYNCOM by Brian Bacon */

#ifndef __DYNCOM_LIB
#define __DYNCOM_LIB

typedef struct {
  long magic;
  long symbol_offset;
  long element_size;
  long nrelocs;
} dcm_header;

typedef struct DCM_STRUCT  DCM;

struct DCM_STRUCT
       {
         void  (*dcm_init)(DCM *dcm);                  // various functions
         void  *(*dcm_var)(DCM *dcm, int var);
         void  *(*dcm_proc)(DCM *dcm, int proc);
         void  *(*ext_var)(int var);
         void  *(*ext_proc)(int proc);
         dcm_header     hdr;                           // file header
         unsigned char  *data;                         // data block
       };

#define DCM_MAGIC 0x31455844
/* data stored after dxe_header in file; then relocs, 4 bytes each */

/* Internal dcm functions called by Load_DCM and Free_DCM */
void *_dcm_load(char *filename, DCM *d);
void _dcm_unload(DCM *d);

DCM *Load_DCM(char *filename, void *ext_proc, void *ext_var);
void Free_DCM(DCM *dcm);

#endif
