/* Sample Ikon Application

        This file was made for use with GCCFI (GCC For Ikon)

*/
#include <ikon.h>          /* ikon.h should ALWAYS be first */
#include <string.h>
#include "c:\djgpp\ikonsrc\gui\gui.h"
#include "start.c"

typedef struct dticons DTICONS;               //desktop icons
struct dticons{
        int used;
        char appname[80];
        char iconfile[80];
        char filename[80];
	char linkfile[80];
};
DTICONS dticon[50];

typedef struct shortcuts SHORTCUTS;     //start menu shortcuts
struct shortcuts{
        char filename[60];
        char groupname[60];
};
SHORTCUTS shortcut[20];

typedef struct groups GROUPS;     //start menu subgroups from main.grp in system dir
struct groups{
        char filename[60];
        char groupname[60];
};
GROUPS group[20];

void launchprogram(int data);
int ourwinid;           //id for our window
int exitbutton;
int testwin;
int box;
int lastdticonclicked;	//which desktopicon was last clicked on
char MainMenu[300];

int timercnt;
int totalitems;
char *fbuff;
FILE *groupfile;
char menustring[200];
char readline[80];


void *var_router(DCM *dcm, int function)
{
        if(function==2){return &RefreshDesktop;}
        if(function==3){return &RefreshEditBox;}
        if(function==4){return &RefreshWin;}
        if(function==5){return &MakeButton;}
        if(function==6){return &MakeWindow;}
        if(function==8){return &CurrentWindow;}
        if(function==9){return &RefreshIcons;}
        if(function==10){return &GetKey;}
        if(function==11){return &GetTextBoxPointer;}
        if(function==12){return &ResetTextBox;}
        if(function==13){return &AddTextBox;}
        if(function==14){return &RefreshTextBox;}
        if(function==15){return &DestroyButton;}
        if(function==16){return &HideWindow;}
        if(function==17){return &GetWinBMP;}
        if(function==18){return &ShowWin;}
        if(function==19){return &DisableButton;}
        if(function==20){return &EnableButton;}
        if(function==21){return &MakeColorButton;}
        if(function==22){return &MakeLabelButton;}
        if(function==23){return &MakeIcon;}
        if(function==24){return &SetFocusOn;}
        if(function==25){return &MouseOver;}
        if(function==26){return &CloseWin;}
        if(function==27){return &SetWallpaper;}
        if(function==28){return &AddEditBox;}
        if(function==29){return &PopMenu;}
        if(function==30){return &ResetWallpaper;}
        if(function==31){return &FileSelector;}
        if(function==32){return &AddListBox;}
        if(function==33){return &AddListItem;}
        if(function==34){return &RefreshListBox;}
        if(function==35){return &GetListBoxSelection;}
        if(function==36){return &ResetListBox;}
        if(function==37){return &GetWinInfo;}
        if(function==38){return &SystemMessage;}
        if(function==39){return &FreeIcon;}
        if(function==40){return &GetMouse;}
        if(function==41){return &RestartEvents;}
        if(function==42){return &GetLastMouseB;}
	if(function==43){return &PutKey;}
	if(function==44){return &MakeCustomButton;}
  return(0);
}

void initdesktop()
{
        FILE *desktopini;
        FILE *systemini;
	struct ffblk f;
        char tempstr[80];
        int x;
        int y;
        int column;
        int row;
        int temp;
        int dummy;
	int done;
        char *fbuff;
        //char readline[80];
        size_t maxchars;     //index into stings in system.ini
        row=0;
        column=0;
        x=0;
        y=0;
        //first we add the desktop wallpaper
	memset(readline,0,sizeof(readline));
        systemini=fopen("system\\system.ini","rt");
   do{
        fbuff=fgets(readline,60,systemini);    //input system.ini line
        readline[strlen(readline)-1]=0;  //get rid of newline character
        if (!fbuff)
        {
                break;
        }
        //now we have to check the line for any config statements
        temp=strncmp(readline,"wallpaper=",10);
        if (temp==0)
        {
                //ITS THE WALLPAPER. LETS GET THE IMAGE FILENAME
                maxchars=strcspn(readline,"=");
                strncpy(tempstr,readline+maxchars+1,50);
        };
   }while(fbuff);
   fclose(systemini);    //close the system.ini file as we're done with it
        SetWallpaper(tempstr);

        //now we add the desktop shortcuts
        dummy=0;
        row=1;
	done=findfirst("desktop\\*.lnk",&f,FA_DIREC);
	while(!done)
	{
		dummy++;
		if(strstr(f.ff_name,".LNK")!=0)
		{
			memset(tempstr,0,sizeof(tempstr));
			strcpy(tempstr,"desktop\\");
			strcat(tempstr,f.ff_name);
			strcpy(dticon[dummy].linkfile,tempstr);
			desktopini=fopen(tempstr,"rt");
	                fbuff=fgets(dticon[dummy].appname,60,desktopini);
	                dticon[dummy].appname[strlen(dticon[dummy].appname)-1]=0;
	                fbuff=fgets(dticon[dummy].filename,60,desktopini);
	                dticon[dummy].filename[strlen(dticon[dummy].filename)-1]=0;
	                fbuff=fgets(dticon[dummy].iconfile,60,desktopini);
	                dticon[dummy].iconfile[strlen(dticon[dummy].iconfile)-1]=0;
	                dticon[dummy].used=1;
	                row=row+1;
	                if(row>8)
	                {
	                        row=2;
	                        column=column+1;
	                }
	                x=(column*110)+50;
	                y=(row*70)-110;
                AddDesktopIcon(x,y,dticon[dummy].iconfile,dticon[dummy].appname,launchprogram,dummy);
			fclose(desktopini);
		}
		done=findnext(&f);
	}
}

void rundrivers()
{
        FILE *systemini;
	struct ffblk f;
        char tempstr[80];
        int temp;
        int dummy;
	int done;
        char *fbuff;
        size_t maxchars;     //index into stings in system.ini
        //first we add the desktop wallpaper
	memset(tempstr,0,sizeof(tempstr));
        systemini=fopen("system\\system.ini","rt");
   do{
        fbuff=fgets(tempstr,60,systemini);    //input system.ini line
        tempstr[strlen(tempstr)-1]=0;  //get rid of newline character
        if (!fbuff)
        {
                break;
        }
        //now we have to check the line for any config statements
        temp=strncmp(tempstr,"driver=",7);
        if (temp==0)
        {
                //load a driver
                maxchars=strcspn(tempstr,"=");
		Load_DLL(tempstr+7);
                //strncpy(tempstr,readline+maxchars+1,50);
        };
   }while(fbuff);
   fclose(systemini);    //close the system.ini file as we're done with it
}

void dorunapp(int data)
{
        RunApp("programs\\netwalk\\netwalk.app");
};

void dofileman(int data)
{
        RunApp("system\\fileman.app");
};

void exithandler(int data)
{
	if(data==1)
	{
		SystemMessage("\r\n\tShutting Down");
		system("fdapm poweroff");
	}
	if(data==2)
	{
		SystemMessage("\r\n\tRestarting....");
		system("fdapm warmboot");
	}
	if(data==3)
	{
		destroy_font(monofont);
		ShutDown();
	}
}


void rightclickdticon(int data)	//right click on desktop icon
{
	int temp;
	temp=CurrentWindow();
	if(data==1)
	{
		RunApp(dticon[lastdticonclicked].filename);
	}
	if(data==2)
	{
		//delete the desktop icons linkfile
		remove(dticon[lastdticonclicked].linkfile);
		//now refresh the icons
		RefreshIcons();
		SetFocusOn(temp);
	}
	if(data==3)
	{
		RefreshIcons();
		SetFocusOn(temp);
	}
}

void launchprogram(int data)
{
	int lastmb;
	lastmb=GetLastMouseB();
	lastdticonclicked=data;
	if(lastmb==1)
	{
	        RunApp(dticon[data].filename);
	}
	else
	{
		//pop a menu asking to delete a desktop shortcut
		PopMenu("Launch,none,Erase Shortcut,none,Refresh Shortcuts,none",rightclickdticon);
	}
}


void exitmenu(int data)
{
	PopMenu("Shutdown,icons\\power.bmp,Restart,icons\\refresh.bmp,Exit To DOS,icons\\fdos.bmp",exithandler);
};


void GUI_time(int data)
{
	char buff[30];
	char buff2[10];
	BITMAP *bmp;
	struct time t;
	int a;
	int b;
	timercnt++;
	a=0;
	if(timercnt>0x200000)
	{
		timercnt=0;
		bmp=GetWinBMP(mainwin);
		gettime(&t);
		memset(buff,0,30);
		memset(buff2,0,10);
		if(t.ti_hour>11 && t.ti_hour!=24)
		{
			t.ti_hour=t.ti_hour-12;
			a=1;	//pm
		}
		if(t.ti_hour==24)
		{
			t.ti_hour=12;
			a=0;
		}
		if(t.ti_hour==0)
		{
			t.ti_hour=12;
			a=1;
		}
		itoa(t.ti_hour,buff2,10);
		strcpy(buff,buff2);
		memset(buff2,0,10);
		itoa(t.ti_min,buff2,10);
		strcat(buff,":");
		if(t.ti_min<10)
			strcat(buff,"0");
		strcat(buff,buff2);
		if(a==1)
		{
			strcat(buff,"pm");
		}
		else
		{
			strcat(buff,"am");
		}
		rectfill(bmp,screen_w-75,6,screen_w,16,guigray);
		textout(bmp,SystemFont(),buff,screen_w-75,6,0);
		RefreshWin(mainwin);
		//RefreshDesktop();
	}
	GenEvent(GUI_time,0);
}


static void appmain()
{
  //*********[ Your main program routine ]****************
        int temp;
        int temp2;
        BITMAP *bmp;
        monofont=load_ttf_font("fonts\\mono-b.ttf",12,1);
        InitGUI();
        GetScreenRes(&screen_w,&screen_h);
        //SetWallpaper("desktop\\wall.bmp");
	mouse=load_bitmap("icons\\mouse.bmp",0);
	mousebuff=getmousebuffer();
        mainwin=MakeTaskBar(0,screen_h-30,1600,30,"Desktop",BlankHandler,0);
        //bmp=GetWinBMP(mainwin);
        //rectfill(bmp,0,0,bmp->w,bmp->h-1,guiblue);
        MakeIcon(mainwin,4,1,"system\\start.bmp","",dostartmenu,0);
        MakeIcon(mainwin,73,3,"icons\\browsers.bmp","",dorunapp,0);
        MakeIcon(mainwin,97,2,"icons\\folder.bmp","",dofileman,0);
	MakeIcon(mainwin,screen_w-75-26,2,"icons\\power.bmp","",exitmenu,0);
        initdesktop();
        RefreshDesktop();
        ShowWin(mainwin);
	initstartmenu();
	rundrivers();
	timercnt=0x200000-1;
        GenEvent(GUI_Events,0);
	GenEvent(GUI_time,0);
};



